(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.jssPluginCache = {}));
})(this, (function (exports) { 'use strict';

  function cachePlugin() {
    var cache = new WeakMap();
    function onCreateRule(name, decl, _ref) {
      var parent = _ref.parent;
      return parent && name ? cache.get(parent.rules.raw[name]) || null : null;
    }
    function onProcessRule(rule) {
      var _rule$options = rule.options,
        sheet = _rule$options.sheet,
        parent = _rule$options.parent;
      if (!parent || sheet && sheet.options.link) {
        return;
      }
      var originalStyle = parent.rules.raw[rule.key];
      if (!cache.has(originalStyle)) cache.set(originalStyle, rule);
    }
    return {
      onCreateRule: onCreateRule,
      onProcessRule: onProcessRule
    };
  }

  exports.default = cachePlugin;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=jss-plugin-cache.js.map
